package ics.uci.edu.Calico.Structures;

import java.awt.Color;
import java.awt.Polygon;
import java.awt.geom.Line2D;
import java.awt.geom.Rectangle2D;

import edu.umd.cs.piccolox.util.LineShape;

import ics.uci.edu.Calico.UI.BGElementPainter;
import ics.uci.edu.Calico.models.BGElementModel;

public class BGElementController {

	public static BGElementModel copy(BGElementModel bge) {
		Polygon p = new Polygon();
		for (int i = 0; i < bge.poly.npoints; i++)
			p.addPoint(bge.poly.xpoints[i], bge.poly.ypoints[i]);
		Color c = new Color(bge.color.getRed(), bge.color.getGreen(), bge.color.getBlue(), bge.color.getAlpha());
		
		return new BGElementModel(p, c, bge.id);
	}
	
	public static boolean containedBy(BGElementModel bge, Polygon p) {
		boolean ret = true;
		for (int i = 0; i < bge.poly.npoints; i++)
			if (!p.contains(bge.poly.xpoints[i], bge.poly.ypoints[i]))
				ret = false;
		
		return ret;
	}
	
	public static boolean intersects(BGElementModel bge, Rectangle2D bounds) {
		return bge.poly.intersects(bounds) || bounds.contains(bge.poly.xpoints[0], bge.poly.ypoints[0]);
	}
	
	/*
	public static void trim(BGElementPainter bge, Rectangle2D bounds) {
		BGElementModel model = bge.getModel();
		
		Line2D line;
		int intersectionLow = -1, intersectionHigh = -1;
		for (int i = 1; i < model.poly.npoints; i++) {
			line = new Line2D.Double(model.poly.xpoints[i-1], model.poly.ypoints[i-1],
									model.poly.xpoints[i], model.poly.ypoints[i]);
			if (bounds.intersectsLine(line)) {
				if (intersectionLow == -1)
					intersectionLow = i - 1;
				intersectionHigh = i;
			}
		}
		
		if (intersectionLow > 1) {
			Polygon low = new Polygon();
			for (int i = 0; i < intersectionLow; i++) {
				low.addPoint(model.poly.xpoints[i], model.poly.ypoints[i]);
			}
			BGElementModel lowModel = new BGElementModel(low, model.color);
			BGElementPainter lowPainter = new BGElementPainter(lowModel);
			bge.getParent().addChild(lowPainter);
			lowPainter.moveToBack();	
		}
		if (intersectionHigh > model.poly.npoints - 3) {
			bge.removeAllPoints();
			bge.getParent().removeChild(bge);
		}
		else {
			bge.removePoints(0, intersectionHigh+1);
			
		}		
	}*/
	
	public static boolean equals(BGElementModel bge1, BGElementModel bge2) {
		if (bge1.poly.npoints != bge2.poly.npoints)
			return false;
		
		for (int i = 0; i < bge1.poly.npoints; i++) {
			if (bge1.poly.xpoints[i] != bge2.poly.xpoints[i] || bge1.poly.ypoints[i] != bge2.poly.ypoints[i]) {
				return false;
			}
		}
		
		return true;
	}
	
}
