package ics.uci.edu.Calico.UI;

import ics.uci.edu.Calico.Structures.RelationshipController;
import ics.uci.edu.Calico.models.RelationshipModel;

import java.awt.BasicStroke;
import java.awt.Graphics2D;
import java.awt.Polygon;
import java.awt.geom.Line2D;
import java.awt.geom.Rectangle2D;
import java.io.Serializable;

import java.awt.geom.Point2D;

import edu.umd.cs.piccolo.util.PPaintContext;
import edu.umd.cs.piccolox.nodes.PLine;

public class RelationshipPainter extends PLine implements Serializable{

	private RelationshipModel rel;
	Polygon arrowHead;
	
	public RelationshipPainter(RelationshipModel r) {
		super();
		rel = r;
		updatePosition();
		this.setStroke(new BasicStroke(1.3f));
	}
	
	public boolean setBounds() {
		Rectangle2D bounds = new Line2D.Double(new Point2D.Double(rel.getX1(), rel.getY1()),
				new Point2D.Double(rel.getX2(), rel.getY2())).getBounds2D();
		if(super.setBounds(bounds.getX(), bounds.getY(), 
				bounds.getWidth(), bounds.getHeight())) {
			return true;
		}
		return false;
	}
	
	public void updatePosition() {
		//This line is vital if you've cloned this object, to fix some null pointer mistake in PLine
		//However, this function only exists in my version of PLine that added it
		//fixLine();
		
		this.removeAllPoints();
		this.addPoint(0, rel.getX1(), rel.getY1());
		this.addPoint(1, rel.getX2(), rel.getY2());
		arrowHead = RelationshipController.getArrow(new Double(rel.x2).intValue(), 
				new Double(rel.y2).intValue(), new Double(rel.x1).intValue(), 
				new Double(rel.y1).intValue(), 20, 10, .5);		
		setStroke(new BasicStroke(
				(float)(.1 * RelationshipController.getThickness(rel))));
	}
	
	public void translate(int scrapId, int deltaX, int deltaY) {
		RelationshipController.translate(rel, scrapId, deltaX, deltaY);
		updatePosition();
		setBounds();
	}

	public RelationshipModel getModel() {
		return rel;
	}
	
	protected void paint(PPaintContext paintContext) {
		Graphics2D g2 = paintContext.getGraphics();
		updatePosition();
		
		if (getStroke() != null && getStrokePaint() != null) {
			g2.setPaint(rel.getColor());
			g2.setStroke(new BasicStroke((float)rel.thickness/3, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
			g2.draw(getLineReference());
			g2.fill(arrowHead);
			g2.draw(arrowHead);
		}		
	}

	public void updateStroke() {
		this.setStroke(new BasicStroke(rel.thickness));	
	}
}
