package ics.uci.edu.Calico.UI.components;

import ics.uci.edu.Calico.UI.CalicoCanvas;
import ics.uci.edu.Calico.models.ObjectHandlerModel;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.geom.Point2D;

import edu.umd.cs.piccolo.PNode;
import edu.umd.cs.piccolo.util.PPaintContext;

/**
 * Bucket preserves an ObjectHandler that can be loaded at a later time.
 * Note: This class is a bit of a relic, it's purpose was replaced by the grid.
 * 
 * @author nmangano
 *
 */
public class Bucket extends PNode {
	
	Image img;
	Image unscaled;
	ObjectHandlerModel model;
	Rectangle rect;
	
	public Bucket(ObjectHandlerModel ohm, Image i, Rectangle r) {
		model = ohm;
		img = CalicoCanvas.getProportionateScaledImage(i, new Double(r.getWidth()).intValue(), 
				new Double(r.getHeight()).intValue(), Image.SCALE_SMOOTH);
		
		unscaled = i;
		rect = r;
		//this.addInputEventListener(new BucketEventListener());
	}
	
	public boolean setBounds() {
		Rectangle r = new Rectangle(rect.x, rect.y, rect.width+1, rect.height+1);
		if (super.setBounds(r))
			return true;
		return false;
	}

	public void paint(PPaintContext aPaintContext) {
		Graphics2D g2 = aPaintContext.getGraphics(); 
		g2.setPaint(getPaint());
		g2.setStroke(new BasicStroke(1.0f));
		
		g2.setColor(Color.WHITE);
		g2.fillRect(rect.x, rect.y, rect.width, rect.height);
		g2.drawImage(img, rect.x, rect.y, null);
		g2.setColor(Color.BLACK);
		g2.drawRect(rect.x, rect.y,rect.width, rect.height);
	}

	public boolean contains(Point2D p) {
		return (rect.contains(p));
	}
	
	public void translate(double dX, double dY) {
		rect.translate(new Double(dX).intValue(), new Double(dY).intValue());
		setBounds();
	}
	
	public ObjectHandlerModel getModel() {
		return model;
	}
	
	public Image getImage() {
		return img;
	}
	
	public Image getUnscaledImage() {
		return unscaled;
	}

	
	
}
