package ics.uci.edu.Calico.UI.components;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Polygon;
import java.awt.geom.Arc2D;
import java.awt.geom.Area;
import java.awt.geom.Rectangle2D;

import edu.umd.cs.piccolo.event.PBasicInputEventHandler;
import edu.umd.cs.piccolo.event.PInputEvent;
import edu.umd.cs.piccolo.util.PPaintContext;
import ics.uci.edu.Calico.UI.Calico;
import ics.uci.edu.Calico.UI.CalicoCanvas;

public class GridNavPointer extends CalicoComponent {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	//Area triangle;
	CalicoCanvas canvas;
	private int componentWidth = 40, componentHeight = 40,
		xOffset = 5, yOffset = 5;
	
	
	public GridNavPointer() {
		System.out.println("Grid Nav Pointer Made");
		addInputEventListener(new GridEventListener());
	}
	
	
	public boolean setBounds(double x, double y, double width, double height) {
		
		/*
		Polygon t = new Polygon();
		t.addPoint(new Double(x).intValue(), new Double(y).intValue());
		t.addPoint(new Double(x + width).intValue(), new Double(y).intValue());
		t.addPoint(new Double(x + width).intValue(), new Double(y + height).intValue());
		
		Arc2D arc = new Arc2D.Double(x - width, y, width * 2, height * 2, 0, 90, Arc2D.PIE);
		//triangle = new Area(t);
		Area ar = new Area(arc);
		//triangle.subtract(ar);
		*/
		
		if (super.setBounds(x,y,width,height))
			return true;		
		return false;
	}
	
	public void paint(PPaintContext context) {
		Graphics2D g2 = context.getGraphics();
		g2.setPaint(new Color(167, 167, 138));
		
		Rectangle2D rect = getBounds().getBounds();
		g2.drawLine(new Double(rect.getX() + rect.getWidth()/4).intValue(), new Double(rect.getY()).intValue(), 
				new Double(rect.getX() + rect.getWidth()/4).intValue(), new Double(rect.getY() + rect.getHeight()).intValue());
		g2.drawLine(new Double(rect.getX() + rect.getWidth()/4 * 2).intValue(), new Double(rect.getY()).intValue(), 
				new Double(rect.getX() + rect.getWidth()/4 * 2).intValue(), new Double(rect.getY() + rect.getHeight()).intValue());
		g2.drawLine(new Double(rect.getX() + rect.getWidth()/4 * 3).intValue(), new Double(rect.getY()).intValue(), 
				new Double(rect.getX() + rect.getWidth()/4 * 3).intValue(), new Double(rect.getY() + rect.getHeight()).intValue());
		
		g2.drawLine(new Double(rect.getX()).intValue(), new Double(rect.getY() + rect.getHeight()/4).intValue(), 
				new Double(rect.getX() + rect.getWidth()).intValue(), new Double(rect.getY() + rect.getHeight()/4).intValue());
		g2.drawLine(new Double(rect.getX()).intValue(), new Double(rect.getY() + rect.getHeight()/4 * 2).intValue(), 
				new Double(rect.getX() + rect.getWidth()).intValue(), new Double(rect.getY() + rect.getHeight()/4 * 2).intValue());
		g2.drawLine(new Double(rect.getX()).intValue(), new Double(rect.getY() + rect.getHeight()/4 * 3).intValue(), 
				new Double(rect.getX() + rect.getWidth()).intValue(), new Double(rect.getY() + rect.getHeight()/4 * 3).intValue());
		
		
		//g2.fill(triangle);
	}
	
	private class GridEventListener extends PBasicInputEventHandler {
		
		public void mousePressed(PInputEvent e) {
			CalicoGrid grid = null;
			
			for (CalicoComponent calicoComponent : canvas.getCalicoComponents())
				if (calicoComponent instanceof CalicoGrid)
					grid = (CalicoGrid)calicoComponent;
			
			if (grid == null)
				System.err.println("Cannot find CalicoGrid in CalicoGrid, something is mega wrong!");
			
			if (GridNavPointer.this.getBounds().contains(e.getCanvasPosition())){
				grid.deactiveCell();
				grid.loadGrid();
			}
		}
		
	}

	@Override
	public void registerCanvas(CalicoCanvas c) {
		canvas = c;
		
		boolean hasGrid = false;
		for (CalicoComponent vbc : canvas.getCalicoComponents())
			if (vbc instanceof CalicoGrid)
				hasGrid = true;
		
		if (!hasGrid) {
			System.err.println("VBCanvas must have VBGrid before this can be added!");
			canvas.getCamera().removeChild(this);
		}		
	}


	@Override
	public boolean updateBounds(int width, int height) {
		if (setBounds(width - componentWidth - xOffset, yOffset, componentWidth, componentHeight))
			return true;
		return false;
	}
	
}
