package ics.uci.edu.Calico.UI.components;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.GradientPaint;
import java.awt.Graphics2D;
import java.awt.geom.Rectangle2D;

import edu.umd.cs.piccolo.event.PBasicInputEventHandler;
import edu.umd.cs.piccolo.event.PInputEvent;
import edu.umd.cs.piccolo.util.PPaintContext;

import ics.uci.edu.Calico.UI.CalicoCanvas;

public class Panning extends CalicoComponent {
	
	private int size = 50;
	CalicoCanvas canvas;

	public Panning() {
		addInputEventListener(new PanningInputHandler());
	}
	
	public void paint(PPaintContext c) {
		
		Graphics2D g = c.getGraphics();
		
		Rectangle2D bounds = getBounds();
		
		
		
		g.setColor(Color.white);
		g.fillOval(new Double(bounds.getX()).intValue(), new Double(bounds.getY()).intValue(), 
				new Double(bounds.getWidth()).intValue(), new Double(bounds.getHeight()).intValue());
		//GradientPaint gp = new GradientPaint(75, 75, Color.white,
		//        95, 95, Color.gray, true);		
		g.setColor(Color.black);
		g.setStroke(new BasicStroke(1.5f));
		g.drawOval(new Double(bounds.getX()).intValue(), new Double(bounds.getY()).intValue(), 
				new Double(bounds.getWidth()).intValue(), new Double(bounds.getHeight()).intValue());
		g.setStroke(new BasicStroke(1.0f));
		g.drawString("Pan", new Double(bounds.getX()+15).intValue(), new Double(bounds.getY()+30).intValue());
	}
	
	@Override
	public void registerCanvas(CalicoCanvas c) {
		canvas = c;
	}

	@Override
	public boolean updateBounds(int width, int height) {
		if (setBounds(width - size - 50, height - size - 50, size, size))
			return true;
		return false;
	}
	
	private class PanningInputHandler extends PBasicInputEventHandler {
		
		private int initX = -1, initY = -1;
		//PanningThread thread;
		
		public void mousePressed(PInputEvent e) {
			initX = new Double(e.getCanvasPosition().getX()).intValue();
			initY = new Double(e.getCanvasPosition().getY()).intValue();
			
			/*
			e.getCamera().translateView(10, 10);
			thread = new PanningThread();
			//thread.setDelta(5, 5);
			thread.run();
			*/
		}
		
		public void mouseDragged(PInputEvent e) {
			int deltaX = new Double(e.getCanvasPosition().getX()).intValue() - initX;
			int deltaY = new Double(e.getCanvasPosition().getY()).intValue() - initY;
			
			e.getCamera().translateView(e.getCanvasDelta().width * 10, e.getCanvasDelta().height * 10);
			/*
			thread.deltaX = deltaX;
			thread.deltaY = deltaY;
			*/
		}
		
		public void mouseReleased(PInputEvent e) {
			//thread.stop();
			//thread = null;
		}
		
	}
	
	/*
	private class PanningThread implements Runnable {

		public int deltaX = 0, deltaY = 0;
		boolean haltThread = false;
		
		public void run() {
			
			while (!haltThread) {
				
				canvas.getCamera().translateView(deltaX, deltaY);
				try {
					canvas.repaint();
					Thread.sleep(500);
				}
				catch (InterruptedException e) {
					
				}
			}
				
		}
		
		public void setDelta(int x, int y) {
			deltaX = x;
			deltaY = y;
		}
		
		public void stop() {
			haltThread = true;
		}
		
	}
	*/

}
