package ics.uci.edu.Calico.UI.components.palettes;


import ics.uci.edu.Calico.Structures.*;
import ics.uci.edu.Calico.UI.*;
import ics.uci.edu.Calico.UI.components.palettes.*;
import ics.uci.edu.Calico.models.*;
import ics.uci.edu.Calico.models.actions.*;

import java.io.*;
import java.util.*;

public class CellContents implements Serializable {
	ArrayList<ScrapModel> scraps;
	ArrayList<RelationshipModel> rels;
	ArrayList<BGElementModel> bgels;
	private static final long serialVersionUID = 1L;
	
	public CellContents(ArrayList<ScrapModel> c, ArrayList<RelationshipModel> r) {
		scraps = c;
		rels = r;
		bgels = new ArrayList<BGElementModel>();
	}
	
	public CellContents(ArrayList<ScrapModel> c, ArrayList<RelationshipModel> r, ArrayList<BGElementModel> b) {
		scraps = c;
		rels = r;
		bgels = b;
	}
	public CellContents()
	{
		scraps = new ArrayList<ScrapModel>();
		rels = new ArrayList<RelationshipModel>();
		bgels = new ArrayList<BGElementModel>();
	}
	
	/**
	 * Copy Constructor
	 * @param c CellContents to copy
	 */
	public CellContents(CellContents c) {
		ArrayList<ScrapModel> smArr = new ArrayList<ScrapModel>();
		for (ScrapModel sm : c.scraps)
			smArr.add(ScrapController.copy(sm));
		scraps = smArr;
		
		ArrayList<RelationshipModel> relArr = new ArrayList<RelationshipModel>();
		for (RelationshipModel rm : c.rels)
			relArr.add(RelationshipController.copy(rm));
		rels = relArr;
		
		
		ArrayList<BGElementModel> bgeArr = new ArrayList<BGElementModel>();
		for (BGElementModel bg : c.bgels)
			bgeArr.add(BGElementController.copy(bg));
		bgels = bgeArr;
		
	}
	public CellContents(HashMap<String,Object> imp)
	{
		scraps = new ArrayList<ScrapModel>();
		rels = new ArrayList<RelationshipModel>();
		bgels = new ArrayList<BGElementModel>();
		
		scraps = (ArrayList) imp.get("s");
		rels = (ArrayList) imp.get("r");
		bgels = (ArrayList) imp.get("b");
	}
	
	public ArrayList<ScrapModel> getScraps() {
		return scraps;
	}
	public ArrayList<RelationshipModel> getRelationships() {
		return rels;
	}
	
	public ArrayList<BGElementModel> getBGElements() {
		return bgels;
	}
	
	public HashMap<String,Object> exportContents()
	{
		HashMap<String,Object> exp = new HashMap<String,Object>();
		
		exp.put("s", (Object) scraps);
		exp.put("r", (Object) rels);
		exp.put("b", (Object) bgels);
		
		return exp;
	}
	

}

