package ics.uci.edu.Calico.classroom;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.event.MouseInputListener;

import ics.uci.edu.Calico.UI.MouseInputHandler;
import ics.uci.edu.Calico.UI.CalicoCanvas;
import ics.uci.edu.Calico.UI.components.Navigator;
import ics.uci.edu.Calico.UI.components.Undo;
import ics.uci.edu.Calico.UI.components.Zoom;
import ics.uci.edu.Calico.models.ObjectHandlerModel;
import ics.uci.edu.Calico.models.actions.CalicoActionListener;
import ics.uci.edu.Calico.networking.ClientWorker;

public class ExpandedFrame extends JFrame{

	private static final long serialVersionUID = 1L;
	private Dimension canvasDimension = new Dimension(590,540);
	
	private ClassroomClientWorker cWorker;
	private Vector<ClassroomClientWorker> activeClientsList;
	private ClassroomMenu menu = new ClassroomMenu();
	private CalicoCanvas canvas;
	private GridBagConstraints c = new GridBagConstraints();
	private boolean expandedFrame;
	private MouseInputHandler mInput;
	
	//EXPANDED FRAME
	public ExpandedFrame(ClassroomClientWorker cWorker, Vector<ClassroomClientWorker> list){
		expandedFrame = true;
		canvas = cWorker.getVBCanvas();
		mInput = new MouseInputHandler(canvas);
		setTitle(cWorker.getNickname()+"'s Canvas");
		setLayout(new GridBagLayout());
		drawMenu();
		this.cWorker = cWorker;
		activeClientsList = list;;
		
		drawFrame();
		
	}
	
	//PREMADE CANVAS EDITOR
	public ExpandedFrame(Vector<ClassroomClientWorker> list){
		expandedFrame = false;
		setTitle("Premade Canvas Editor");
		setLayout(new GridBagLayout());
		drawMenu();
		activeClientsList = list;
		drawFrame();
	}
	
	public ExpandedFrame(){
		expandedFrame = false;
		setTitle("Premade Canvas Editor");
		setLayout(new GridBagLayout());
		drawMenu();
		//this.activeServersList = activeServersList;
		drawFrame();
	}
	
	private void drawMenu(){
		menu.addSendCanvasAll(this);
		menu.addSaveOption(canvas, canvas);
		menu.addLoadGridOption(canvas);
		//menu.addExitOption();
	}
	
	private void drawCanvas(){
		//cWorker.getVBCanvas().getCamera().scaleViewAboutPoint(5, 0, 0);
		//canvas.changeModel(cWorker.getVBCanvas().getModel());
		
		
		
		canvas.getCamera().scaleViewAboutPoint(5, 0, 0);
		canvas.addInputEventListener(mInput);
		canvas.removeInputEventListener(canvas.getZoomEventHandler());
		canvas.removeInputEventListener(canvas.getPanEventHandler());
		canvas.setPreferredSize(canvasDimension);
		
		//canvas.addComponent(new Zoom());
		//canvas.addComponent(new Undo());		
		//canvas.addComponent(new Navigator());
	}
	
	private void drawPreMadeFrame(){
		canvas = new CalicoCanvas();
		canvas.setPreferredSize(canvasDimension);
		canvas.setVisible(true);
		canvas.addInputEventListener(new MouseInputHandler(canvas));
		canvas.removeInputEventListener(canvas.getZoomEventHandler());
		canvas.removeInputEventListener(canvas.getPanEventHandler());
		canvas.addComponent(new Zoom());
		canvas.addComponent(new Undo());		
		canvas.addComponent(new Navigator());
	}
	
	private void drawFrame() {
		
		setBackground(Color.DARK_GRAY);
		setPreferredSize(new Dimension(600,610));
		
		if(expandedFrame){
			drawCanvas();
			windowListener();
		}
		else
			drawPreMadeFrame();
		
		c.fill = GridBagConstraints.HORIZONTAL  ;
		//c.fill = GridBagConstraints.VERTICAL;
		c.weightx = 1.0;
		c.weighty = 0;
		c.gridy = 0;
		c.gridwidth = 4;
		c.anchor = GridBagConstraints.FIRST_LINE_START;
		add(menu,c);
		
		// TODO fix resize
		c.fill = GridBagConstraints.BOTH;
		//c.fill = GridBagConstraints.VERTICAL;
		c.weightx = 1.0;
		c.weighty = 1.0;
		c.gridy = 1;
		c.anchor = GridBagConstraints.FIRST_LINE_START;
		add(canvas,c);
	    
	    setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
	    
	    setVisible(true);
	    repaint();
	    pack();
	}
	
	private void windowListener(){
		addWindowListener(new WindowListener() {
			public void windowActivated(WindowEvent arg0) {}
			public void windowClosed(WindowEvent arg0) {}
			public void windowClosing(WindowEvent arg0) {
				//canvas.removeAllComponents();
				canvas.removeInputEventListener(mInput);///TODO check this
				cWorker.setCanvas(canvas);}
			public void windowDeactivated(WindowEvent arg0) {}
			public void windowDeiconified(WindowEvent arg0) {}
			public void windowIconified(WindowEvent arg0) {}
			public void windowOpened(WindowEvent arg0) {}
	    });
	}

	
	public CalicoCanvas getCanvas(){
		return canvas;
	}
	
	public Vector<ClassroomClientWorker> getActiveClientsList(){
		return activeClientsList;
	}
	
	private void message(String message){
		   JFrame errorFrame = new JFrame();
		   JOptionPane.showMessageDialog(errorFrame,
				    message,
				    "Server Message",
				    JOptionPane.INFORMATION_MESSAGE);
		   
	   }
	
}
