package ics.uci.edu.Calico.models;


import java.awt.Color;
import java.io.Serializable;
import java.util.ArrayList;

/**
 * ObjectHandlerModel contains the variables of the canvas.
 * 
 * @author nmangano
 *
 */
public class ObjectHandlerModel implements Serializable {

	/**
	 * 
	 */
	public static Color defaultBackground = Color.white;
	
	private static final long serialVersionUID = 1L;
	public ArrayList<ScrapModel> scraps;
	public ArrayList<RelationshipModel> relationships;
	public ArrayList<BGElementModel> bgElements;
	public Color bgColor;
	
	//Counting index to assign id's to scraps.
	public int objectIdTicker;
	
	public ObjectHandlerModel() {
		scraps = new ArrayList<ScrapModel>();
		relationships = new ArrayList<RelationshipModel>();
		bgElements = new ArrayList<BGElementModel>();
		bgColor = defaultBackground;
		objectIdTicker = 0;
	}
	
	//Alex:Copy constructor. May not need this later, trying for now
	public ObjectHandlerModel(ObjectHandlerModel ohm){
		scraps = (ArrayList<ScrapModel>)ohm.scraps.clone();
		relationships = (ArrayList<RelationshipModel>)ohm.relationships.clone();
		bgElements = (ArrayList<BGElementModel>)ohm.bgElements.clone();
		objectIdTicker = ohm.objectIdTicker;
	}
	
}
