	package ics.uci.edu.Calico.models;

import java.awt.Color;
import java.awt.geom.Point2D;
import java.io.Serializable;
import java.awt.Color;

public class RelationshipModel implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public int thickness;
	public int hook1, hook2;
	public double x1, y1, x2, y2;
	public int id;
	
	public static Color defaultColor = Color.BLACK;
	private Color color;
	
	public RelationshipModel (int h1, int h2, Point2D p1, Point2D p2, int id) {
		thickness = 10;
		hook1 = h1;
		hook2 = h2;
		this.x1 = p1.getX();
		this.x2 = p2.getX();
		this.y1 = p1.getY();
		this.y2 = p2.getY();		
		this.id = id;
		color = defaultColor;
	}
	
	public RelationshipModel (int h1, int h2, double x1, double y1, double x2, double y2, int id) {
		thickness = 10;
		hook1 = h1;
		hook2 = h2;
		this.x1 = x1;
		this.x2 = x2;
		this.y1 = y1;
		this.y2 = y2;		
		this.id = id;
		color = defaultColor;
	}
	
	public double getX1(){
		return x1;}	
	public double getY1(){
		return y1;}	
	public double getX2(){
		return x2;}	
	public double getY2(){
		return y2;}	
	public void setX1(double i){
		x1 = i;}	
	public void setY1(double i){
		y1 = i;}	
	public void setX2(double i){
		x2 = i;}	
	public void setY2(double i){
		y2 = i;}	
	
	public boolean equals(RelationshipModel r) {
		return id == r.id;
	}
	
	public boolean equals(int i) {
		return id == i;
	}
	
	public void setColor(Color newColor){
		color = newColor;
	}
	
	public Color getColor(){
		return color;
	}
	
	//Returns whether the passed relationship is at the same location as this one
	public boolean compareLocation(RelationshipModel rm){
		if(rm.getX1() != x1)
			return false;
		if(rm.getY1() != y1)
			return false;
		if(rm.getX2() != x2)
			return false;
		if(rm.getY2() != y2)
			return false;
		return true;
	}
}
