package ics.uci.edu.Calico.networking;

import java.io.Serializable;
import java.util.ArrayList;

import ics.uci.edu.Calico.UI.components.CalicoGrid;
import ics.uci.edu.Calico.models.ObjectHandlerModel;
import ics.uci.edu.Calico.models.actions.CalicoAction;

public class NetworkPacket implements Serializable{
	
	final public int CALICO_ACTION = 0;
	final public int PREMADE_CANVAS = 1;
	final public int NICKNAME = 2;
	final public int GRID = 3;
	final public int GRID_REQUEST = 4;
	final public int CANVAS_ACTIVATION_REQUEST = 5;
	final public int CALICO_ACTION_ID = 6;
	
	private static final long serialVersionUID = 1L;
	private int packetID;
	private CalicoAction cAction;
	private ObjectHandlerModel premadeCanvas;
	private String nickname;
	private boolean alive;
	private ArrayList<SerializedCell> calicoGrid;
	private int calicoCellID;
	
	
	public NetworkPacket(CalicoAction cAction){
		this.cAction = cAction;
		this.nickname = System.getProperty("user.name");
		packetID = CALICO_ACTION;
	}
	
	public NetworkPacket(CalicoAction cAction, int id, String nickname){
		this.cAction = cAction;
		this.calicoCellID = id;
		this.nickname = nickname;
		packetID = CALICO_ACTION_ID;
	}
	
	public NetworkPacket(ObjectHandlerModel premadeCanvas){
		this.premadeCanvas = premadeCanvas;
		packetID = PREMADE_CANVAS;
	}
	
	public NetworkPacket(String nickname){
		this.nickname = nickname;
		packetID = NICKNAME;
	}
	
	public NetworkPacket(boolean alive){
		this.alive = alive;
	}
	
	public NetworkPacket(ArrayList<SerializedCell> calicoGrid){
		this.calicoGrid = calicoGrid;
		packetID = GRID;
	}
	
	public NetworkPacket(char gridRequest){
		packetID = GRID_REQUEST;
		System.out.println("Client: grid request packet made!");
	}
	
	public NetworkPacket(int id, String nickname){
		calicoCellID = id;
		this.nickname = nickname;
		packetID = CANVAS_ACTIVATION_REQUEST;
	}
	
	public ArrayList<SerializedCell> getCalicoGrid(){
		return calicoGrid;
	}
	
	public int getPacketID(){
		return packetID;
	}
	
	public CalicoAction getCalicoAction(){
		return cAction;
	}
	
	public ObjectHandlerModel getPremadeCanvas(){
		return premadeCanvas;
	}
	
	public String getNickname(){
		return nickname;
	}
	
	public int getCanvasID(){
		return calicoCellID;
	}
	
	public boolean isAlive(){
		return alive;
	}

}
