#!/usr/bin/perl

use strict;
no strict 'vars';

use IO::Socket;
use IO::Select;

# The Commands
use constant SEND_CELL_CONTENTS => 1;
use constant SEND_CELL_IMAGE => 2;
use constant GET_CELL_CONTENTS => 3;
use constant GET_CELL_IMAGE => 4;
use constant DELETE_CELL => 5;

# use threads;
#use Thread::Queue;

#sub dec2ip ($) 
#{
#	return join '.' => map { ($_[0] >> 8*(3-$_)) % 256 } 0 .. 3;
#}


# NEW CALICO PROTOCOL
# BYTE1 - First part of command
# BYTE2 - Second part of command
# ByTE3-X: Remainder: Params+Data (dependent on command)


print "\nPALETTES DAEMON LISTENING...\n";

my %palettes = ();
my %images = ();

# setup the log listener on UDP
my $s_socket = IO::Socket::INET->new(
	Proto=>"udp", 
	LocalAddr=>"0.0.0.0", 
	LocalPort=>"8787",
	Timeout=>0) or die ("\nCan't setup UDP socket: $!\n");

# loop for ebber and ebber
while( 1 )
{
	if(IO::Select->new($s_socket)->can_read())
	{
		my $s_output = "";
		$s_socket->recv($s_output, 10240);
		
		my ($command,$p1,$p2,$p3,$p4,$p5,$p6,$p7,$p8,$p9,$p10,$p11,$p12,$p13,$p14,$p15,@data) = unpack("C16 c*",$s_output);
		my $port = $s_socket->peerport;
		my $host = $s_socket->peerhost;
		my @params = ($p1,$p2,$p3,$p4,$p5,$p6,$p7,$p8,$p9,$p10,$p11,$p12,$p13,$p14,$p15);
		
		print $command." ($host:$port): ".join(",",@params)." [recv ".scalar(@data)." bytes]\n";
		
		if( $command == SEND_CELL_CONTENTS )
		{
			$palettes{$p1} = join(",",@data);
		}
		elsif($command==SEND_CELL_IMAGE)
		{
			$images{$p1} = join(",",@data);
		}
		elsif($command==GET_CELL_CONTENTS)
		{
			my $sock = IO::Socket::INET->new(Proto => 'udp', PeerPort  => $port, PeerAddr  => $host) or die "Creating socket: $!\n";
			if (exists $palettes{ $p1 })
			{
				my $msg = pack("c*",split(/,/,$palettes{ $p1 } ));
				$sock->send($msg) or die "send: $!";
			}
			else
			{
				my $msg = pack("c",0);
				$sock->send($msg) or die "send: $!";
			}
		}
		elsif($command==GET_CELL_IMAGE)
		{
			my $sock = IO::Socket::INET->new(Proto => 'udp', PeerPort  => $port, PeerAddr  => $host) or die "Creating socket: $!\n";
			
			if (exists $images{ $p1 })
			{
				my $msg = pack("c*",split(/,/,$images{$p1}) );
				$sock->send($msg) or die "send: $!";
			}
			else
			{
				my $msg = pack("c",0);
				$sock->send($msg) or die "send: $!";
			}
		}
		elsif($command==DELETE_CELL)
		{
			delete( $images{$p1} );
			delete( $palettes{$p1} );
		}
		
	}#listening
	else
	{
	
	}
}#while
